import { Application, Context, DefaultContext } from 'koa';
import { IMiddleware } from 'koa-router';
import { RedisClient } from 'redis';
import { responseHandle } from '@utils/response';
import { InterfaceDB } from '../middlewares/localDb';
import { Redis } from '@/plugins';

interface logFn {
  (message: any, ...args: any[]): void;
}
interface interfaceLog {
  trace: logFn
  debug: logFn
  info: logFn
  warn: logFn
  error: logFn
  fatal: logFn
  mark: logFn
}

declare module 'koa' {
  export interface Context extends DefaultContext {
    $redis: Redis
    $response: responseHandle
    $log: interfaceLog
    $db: InterfaceDB
  }
}
